;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.com

window      ;włącz rysowanie poza obszarem okna
hideturtle  ;ukryj ikonę żółwia
:pool_cfg,"refresh := false ;wyłącz automatyczne odświeżanie grafiki
:pool_cfg,"scale_x := 50    ;skala rysowania w poziomie
:pool_cfg,"scale_y := 50    ;skala rysowania w pionie

;Rysuje funkcję zmiennej :x, której wzór zapisany jest w
;postaci listy w argumencie :fn, w zakresie od :x0 do :x1.
;Wartość funkcji jest obliczana w :npkt równomiernie
;rozmieszczonych punktach.
to rysuj :fn :x0 :x1 :npkt
  clean
  let "b true ;zabezpiecza przed rysowaniem poza dziedziną funkcji
  let "x :x0
  let "y run :fn    ;*** y = fn(x) ***
  if !validnum? :y ["y := 0 "b := false]
  penup setxy :x :y
  for [x :x0 :x1 [(:x1 - :x0) / :npkt]] [
    "y := run :fn   ;*** y = fn(x) ***
    ifelse validnump :y [
      if :b [pendown]
      setxy :x :y
      "b := true
    ] [
      penup setxy :x 0
      "b := false
    ]
  ]
  refresh ;odśwież grafikę po zakończeniu rysowania
end

;Funkcja obsługi zdarzenia zmiany położenia krawędzi okna graficznego
;- występuje podczas zmiany rozmiaru okna i przewijania zawartości.
to onworldchanged :walls
  rysuj parse gettext :eq :walls,1 :walls,2 500
end

"eq := textbox "|radsin :x| {10 4 200 24} ;tekst równania funkcji

"go := (button "Rysuj {212 4 70 24} [ ;przycisk odmalowania funkcji
  rysuj parse gettext :eq  ~
  :pool_inf,"wall_left ~
  :pool_inf,"wall_right 500
])

